﻿' Copyright © exc-jdbi 2017
'
' © NumeralSystemConverter1000 2017
'
' NumeralSystemConverter1000 is Free and Opensource Software
'
' www.vb-paradise.de/index.php/User/23082-exc-jdbi/
'
' github.com/exc-jdbi

Option Strict On
Option Explicit On
Imports System.Text 'GetBytes

Public Module ModNSC
    'Macht aus eine Integer-Array einen numerischen String per lambda. (Optional mit Trennzeichen)
    Private Function MakeStringNum(ByVal i() As Integer, Optional ByVal _dgt As Boolean = True) As String
        If _dgt Then
            Return String.Join("", i.Select(Function(x) x.ToString.Trim).ToArray)
        End If
        Return String.Join("-", i.Select(Function(x) x.ToString.Trim).ToArray)
    End Function
    'AusgabeText. Sollte selbsterklärend sein. Siehe Ausgabe Konsole.
    Private Sub PrintOut(ByVal start As String, ByVal target As String, ByVal startBase As Integer, ByVal targetBase As Integer, ByVal sd As Integer, ByVal td As Integer, ByVal sw As Stopwatch)
        Console.WriteLine("[startBase,targetBase] = {0}, {1}{2}", startBase.ToString, targetBase.ToString, vbCrLf)
        Console.WriteLine(start) : Console.WriteLine()
        Console.WriteLine(target) : Console.WriteLine()
        Console.WriteLine("startDigits{0}{1}pcs.", vbTab, sd.ToString)
        Console.WriteLine("targetDigits{0}{1}pcs.", vbTab, td.ToString)
        Console.WriteLine("Time elapsed:{0}{1}ms", vbTab, sw.ElapsedMilliseconds.ToString)
        Console.WriteLine()
    End Sub

    'Testlauf
    Public Sub Main()
        'Instanzieren der benötigten Klassen
        'NSC ist der Numeral System Converter
        'Random1000 ist eine Klasse um den Anfangswert in der gewünschten Startbasis zu erhalten
        'Stopwatch ist eine .Net-Klasse und wird benötigt, um die Zeit zu messen.
        Dim n As New NSC
        Dim r As New Random1000
        Dim sw As New Stopwatch

        'Start- und Zielbasis bekannt geben
        Dim startBase As Integer = 10
        Dim targetBase As Integer = 100

        'Zufälliger Anfangswert (Array) anfordern
        Dim iNum() As Integer = r.NewRnd1000(startBase)

        'Prüfen ob erhaltener Anfangswert gültig ist.
        If iNum IsNot Nothing Then
            'Zeitmessung einleiten.
            sw.Start()

            'iNum = New Integer() {35, 97, 3, 35, 1, 32, 5, 16}
            'iNum = New Integer() {3, 5, 9, 7, 0, 3, 3, 5, 0, 1, 3, 2, 0, 5, 1, 6}

            'Berechnung durchführen
            Dim res() As Integer = n.convert(iNum, startBase, targetBase)

            'Zeitmessung stoppen
            sw.Stop()

            'Prüfen ob der erhalte Zielwert gültig ist.
            If res IsNot Nothing Then
                'Aus dem Anfangswert einen String machen.
                Dim sNum As String = MakeStringNum(iNum, False)

                'Aus dem Zielwert einen String machen.
                Dim sRes As String = MakeStringNum(res, False)

                'Auf der Konsole ausgeben.
                PrintOut(sNum, sRes, startBase, targetBase, iNum.Length, res.Length, sw)
            End If
        End If

        'Konsole anzeigen
        Console.ReadKey()
    End Sub
End Module


